Imports System.Data.sqlclient
Public Class frmAppBD

    'objeto datatabel, adapter, connection e dataset
    Private dt As DataTable
    Private da As SqlDataAdapter
    Private connBD As SqlConnection
    Private ds As DataSet
    'controle a posico do registro atual
    Private registro As Integer
    'armazena a string de conexo
    Private strcon As String
    Private Sub frmAppBD_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        'string de conexo com o SQL Server 2005 Express local
        strcon = "Data Source=.\SQLEXPRESS;AttachDbFilename=D:\Documents and Settings\Macoratti.MACORATI\Meus documentos\Cadastro.mdf;Integrated Security=True;Connect Timeout=30;User Instance=True"
        'instruo sql para selecionar todos os registros da tabela clientes
        Dim strSQL As String = "Select * from Clientes order by codigo"

        Try
            'cria um dataset , preenche e carrega a tabela clientes
            Dim conBD As New SqlConnection(strcon)
            ds = New DataSet
            da = New SqlDataAdapter(strSQL, strcon)

            da.Fill(ds, "Clientes")
            dt = ds.Tables("Clientes")

            If dt.Rows.Count > 0 Then
                registro = 0
                btnPrimeiro_Click(Nothing, Nothing)
            Else
                registro = -1
                btnAtualizar.Enabled = False
                btnEliminar.Enabled = False
            End If
        Catch ex As Exception
            MessageBox.Show("Erro: " & ex.Message, "Sem conexo", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Exit Sub
        End Try

    End Sub
    Private Sub btnNovo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNovo.Click
        If btnNovo.Text = "Novo" Then
            For Each c As Control In Me.grpClientes.Controls
                If TypeOf c Is TextBox Then
                    c.Text = ""
                End If
            Next
            btnAtualizar.Enabled = False
            btnEliminar.Enabled = False
            btnEncerrar.Text = "Cancela"
            btnNovo.Text = "Incluir"
            txtNome.Focus()
        ElseIf btnNovo.Text = "Incluir" Then
            Dim dr As DataRow = dt.NewRow
            incluirRegistro(dr)
            btnNovo.Text = "Novo"
            btnEncerrar.Text = "Encerra"
            btnAtualizar.Enabled = True
            btnEliminar.Enabled = True
        End If
    End Sub
    Private Sub btnUltimo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnUltimo.Click
        registro = dt.Rows.Count - 1
        exibirDados(registro)
    End Sub

    Private Sub btnProximo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnProximo.Click
        Dim i As Integer = dt.Rows.Count - 1
        registro = registro + 1
        If registro > i Then registro = i
        exibirDados(registro)
    End Sub
    Private Sub btnPrimeiro_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPrimeiro.Click
        registro = 0
        exibirDados(registro)
    End Sub

    Private Sub btnAnterior_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAnterior.Click
        registro = registro - 1
        If registro < 0 Then registro = 0
        exibirDados(registro)
    End Sub
    Private Sub btnEliminar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEliminar.Click

        If registro < 0 OrElse registro > dt.Rows.Count - 1 Then
            Exit Sub
        Else
            Dim codigo As Integer
            codigo = CType(txtCodigo.Text, Integer)
            eliminarRegistro(codigo)
        End If

    End Sub
    Private Sub btnAtualizar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAtualizar.Click
        If registro < 0 OrElse registro > dt.Rows.Count - 1 Then Exit Sub

        Dim dr As DataRow = dt.Rows(registro)
        atualizarRegistro(dr)

    End Sub
    Private Sub btnEncerrar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEncerrar.Click
        If btnEncerrar.Text = "Encerra" Then
            If MessageBox.Show("Deseja encerrar a aplicao", "Encerrar", MessageBoxButtons.YesNo) = Windows.Forms.DialogResult.Yes Then
                If ds.HasChanges Then
                    ds.AcceptChanges()
                End If
                Me.Close()
            End If
        ElseIf btnEncerrar.Text = "Cancela" Then
            btnEncerrar.Text = "Encerra"
            btnAtualizar.Enabled = True
            btnEliminar.Enabled = True
            btnNovo.Text = "Novo"
            btnAnterior_Click(Nothing, Nothing)
        End If
    End Sub
    Private Sub incluirRegistro(ByVal dr As DataRow)
        Dim sqlInclui As String
        Dim reg As Integer
        Dim sqlComando As SqlCommand

        atribuirDados(dr)

        sqlInclui = "INSERT INTO Clientes (Nome,Endereco,Cidade,Estado,Nascimento,Email,Comentarios)VALUES ('" & txtNome.Text & "','" & txtEndereco.Text & "','" & txtCidade.Text & "','" & txtEstado.Text & "','" & txtNascimento.Text & "','" & txtEmail.Text & "','" & txtComentarios.Text & "')"
        connBD = New SqlConnection(strcon)
        sqlComando = New SqlCommand(sqlInclui, connBD)
        da.InsertCommand = sqlComando

        Try
            connBD.Open()
            reg = sqlComando.ExecuteNonQuery
            If reg > 0 Then
                MsgBox("Incluido com sucesso.")
                da.Update(ds, "Clientes")
                ds.Tables("Clientes").Reset()
                da.Fill(ds, "Clientes")
                dt = ds.Tables("Clientes")
            End If

        Catch ex As Exception
            MessageBox.Show("Erro : " & vbCrLf & ex.Message, "Erro", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Finally
            connBD.Close()
        End Try
    End Sub
    Private Sub atualizarRegistro(ByVal dr As DataRow)

        Dim sqlAltera As String
        Dim reg As Integer
        Dim sqlComando As SqlCommand

        atribuirDados(dr)

        sqlAltera = "UPDATE Clientes SET Nome = '" & txtNome.Text & "',Endereco= '" & txtEndereco.Text & "',Cidade = '" & txtCidade.Text & "',Estado = '" & txtEstado.Text & "',Nascimento = '" & txtNascimento.Text & "',Email = '" & txtEmail.Text & "',Comentarios = '" & txtComentarios.Text & "'"
        connBD = New SqlConnection(strcon)
        sqlComando = New SqlCommand(sqlAltera, connBD)
        da.UpdateCommand = sqlComando

        Try
            connBD.Open()
            reg = sqlComando.ExecuteNonQuery
            If reg > 0 Then
                MsgBox("Registro alterado com sucesso.")
                da.Update(ds, "Clientes")
                da.Fill(ds, "Clientes")
                dt = ds.Tables("Clientes")
            End If

        Catch ex As Exception
            MessageBox.Show("Erro : " & vbCrLf & ex.Message, "Erro", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Finally
            connBD.Close()
        End Try
    End Sub
    Private Sub eliminarRegistro(ByVal codigo As Integer)

        Dim sqlElimina As String
        Dim reg As Integer
        Dim sqlComando As SqlCommand

        sqlElimina = "DELETE FROM Clientes WHERE Codigo  = " & codigo
        connBD = New SqlConnection(strcon)
        sqlComando = New SqlCommand(sqlElimina, connBD)
        da.DeleteCommand = sqlComando

        Try
            connBD.Open()
            reg = sqlComando.ExecuteNonQuery
            If reg > 0 Then
                MsgBox("Registro Excludo com sucesso.")
                da.Update(ds, "Clientes")
                ds.Tables("Clientes").Reset()
                da.Fill(ds, "Clientes")
                dt = ds.Tables("Clientes")
            End If

        Catch ex As Exception
            MessageBox.Show("Erro : " & vbCrLf & ex.Message, "Erro", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Finally
            connBD.Close()
        End Try
    End Sub
    Private Sub exibirDados(ByVal m As Integer)

        Dim i As Integer = dt.Rows.Count - 1

        If m < 0 OrElse i < 0 Then Exit Sub

        Dim dr As DataRow = dt.Rows(m)

        txtCodigo.Text = dr("Codigo")
        txtNome.Text = dr("Nome")
        txtEndereco.Text = dr("Endereco")
        txtCidade.Text = dr("Cidade")
        txtEstado.Text = dr("Estado")
        txtNascimento.Text = dr("Nascimento")
        txtEmail.Text = dr("Email")
        txtComentarios.Text = dr("Comentarios")

        btnAtualizar.Enabled = True
        btnEliminar.Enabled = True
    End Sub
    Private Sub atribuirDados(ByVal dr As DataRow)

        Dim datatmp As Date
        Dim data As String

        dr("Nome") = txtNome.Text
        dr("Endereco") = txtEndereco.Text
        dr("Cidade") = txtCidade.Text
        dr("Estado") = txtEstado.Text

        If txtNascimento.Text.Length = 0 Or Not IsDate(txtNascimento.Text) Then
            dr("Nascimento") = DBNull.Value
        Else
            datatmp = Convert.ToDateTime(txtNascimento.Text)
            Data = datatmp.Year.ToString & "-" & datatmp.Month.ToString & "-" & datatmp.Day.ToString
            dr("Nascimento") = data
        End If

        dr("Email") = txtEmail.Text
        dr("Comentarios") = txtComentarios.Text
    End Sub
End Class
